'use strict';

var http = require('http');
var https = require('https');
var url = require('url');
var util = require('../common/util');

// copy from node-http-proxy.  ^_^

// create connectHandler function
module.exports = function createUpgradeHandler() {

    // return
    return function upgradeHandler(req, cltSocket, head, ssl) {
        var clientOptions = util.getOptionsFormRequest(req, ssl);
        var proxyReq = (ssl ? https : http).request(clientOptions);
        proxyReq.on('error', onOutgoingError);
        proxyReq.on('response', function (res) {
            // if upgrade event isn't going to happen, close the socket
            if (!res.upgrade) socket.end();
        });

        proxyReq.on('upgrade', function (proxyRes, proxySocket, proxyHead) {
            proxySocket.on('error', function (e) {
                console.error(e);
            });

            cltSocket.on('error', function () {
                proxySocket.end();
            });

            common.setupSocket(proxySocket);

            if (proxyHead && proxyHead.length) proxySocket.unshift(proxyHead);

            cltSocket.write(Object.keys(proxyRes.headers).reduce(function (head, key) {
                var value = proxyRes.headers[key];

                if (!Array.isArray(value)) {
                    head.push(key + ': ' + value);
                    return head;
                }

                for (var i = 0; i < value.length; i++) {
                    head.push(key + ': ' + value[i]);
                }
                return head;
            }, ['HTTP/1.1 101 Switching Protocols']).join('\r\n') + '\r\n\r\n');

            proxySocket.pipe(cltSocket).pipe(proxySocket);
        });
    };
};